;; multi-1.clj
;; Dispatch on type (via keyword)

(defn rect [wd ht] {:Shape :Rect :wd wd :ht ht})

(defn circle [radius] {:Shape :Circle :radius radius})

(defmulti area :Shape)

(defmethod area :Rect [r]
    (* (:wd r) (:ht r)))

(defmethod area :Circle [c]
    (* (. Math PI) (* (:radius c) (:radius c))))

(defmethod area :default [x]
  (println "cannot take area of unknown type"))

(def r (rect 4 5))
(def c (circle 10))

; nREPL eval buffer: C-c C-k
; (area r)
; (area c)
; (area 123)
